#ifndef _Human_being_H
#define _Human_being_H

#include <string>

class Human_being {
private:
	const std::string _nickname; // Non-dynamical field
	// 'const Human_being* _my_buddies[];' does not allow later assignment through 'new':
	const Human_being** _my_buddies;
public:
	Human_being(const std::string&, unsigned = 5);
	Human_being(const Human_being&); // Copy constructor or initialization
	~Human_being(); // Required destructor
	const Human_being& operator=(const Human_being&); // Assignment redefinition
};

#endif /* _Human_being_H */

