#include "Human_being.h"

Human_being::Human_being(const std::string& nickname, unsigned my_friends_capacity) : _nickname(nickname) {
	_my_buddies = new const Human_being * [my_friends_capacity];
}

Human_being::Human_being(const Human_being& hb) : _nickname(hb._nickname) {
	_my_buddies = new const Human_being * [sizeof(hb._my_buddies) / sizeof(hb._my_buddies[0])];
	for (int i = 0; i < sizeof(hb._my_buddies) / sizeof(hb._my_buddies[0]); i++) {
		_my_buddies[i] = hb._my_buddies[i];
	}
}

Human_being::~Human_being() {
	delete[] _my_buddies;
}

const Human_being& Human_being::operator=(const Human_being& hb) {
	if (this != &hb) { // Weird case: 'Human_being hb; hb = hb;'
		this->~Human_being(); // A bit weird, but...
		this->_my_buddies = new const Human_being * [sizeof(hb._my_buddies) / sizeof(hb._my_buddies[0])];
		for (int i = 0; i < sizeof(hb._my_buddies) / sizeof(hb._my_buddies[0]); i++) {
			this->_my_buddies[i] = hb._my_buddies[i];
		}
	}
	return *this;
}

int main(int argc, char** argv) {
	Human_being Franck("Bab", 10);
	Human_being FranckBis = Franck; // Initialization!
	Human_being FranckTer("?");
	FranckTer = Franck; // Assignment!

	return 0;
}

